#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include "drzewo.h"
#define NULL 0
/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  dodaj
 *  Description:  Dodaje 'slowo' do drzewa (galezi) wskazanego przez 'd' umieszczajac je
 *  w porzadku alfabetycznym. Wartoscia zwracana jest adres drzewa (wezla) po aktualizacji 
 *  jego zawartosci. 
 * =====================================================================================
 */
struct drzewo* dodaj(struct drzewo *d,char *slowo)
{
	struct drzewo *wezel=NULL;
	if(!d)
	{
		// tworzenie nowego wezla wezel;
		if((wezel=(struct drzewo*)malloc(sizeof(struct drzewo)))==NULL) return NULL;
		else
		{
			wezel->slowo=(char*)malloc(strlen(slowo)+1);
			strcpy(wezel->slowo,slowo);
			wezel->ilosc=1;
			wezel->left=wezel->right=NULL;
		}

		return wezel;
		
	}
	if(strcmp(d->slowo,slowo)==0)      
	{
		d->ilosc++;
		return d;
	}
	if(strcmp(d->slowo,slowo)>0) d->left=dodaj(d->left,slowo);
	else d->right=dodaj(d->right,slowo);

	return d;
}

/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  wyswietl
 *  Description: Wyswietla zawartosc drzewa (galezi) poczynajac od najbardziej skrajnego 
 *  lewego wezla do najdalszego wezla na prawo. Wyswietlana jest lista slow w porzadku 
 *  alfabetycznym i ilosc  wystapien slow w drzewie.
 * =====================================================================================
 */
void wyswietl(struct drzewo *d)
{
	if(!d) return ;
	wyswietl(d->left);
	printf("%20s %d\n",d->slowo,d->ilosc);
	wyswietl(d->right);
	
}



/* 
 * ===  FUNCTION  ======================================================================
 *         Name:  zwolnij
 *  Description:  Usuwa z pamieci strukture drzewa.
 * =====================================================================================
 */
void zwolnij(struct drzewo *d)
{
   if(!d)
   {
      free(d->slowo);
      zwolnij(d->left);
      zwolnij(d->right);
      free(d);
   }
}
